<template>
  <div class="m-4 modals">
    <div>
      <XTTitle title="药品管理" :right-data="titleData" @click="callTitleClick" />
      <div class="flex items-center justify-between my-4">
        <XTTab
          type="illness"
          :width="180"
          :selected="tabSelected"
          :data="typeOptions"
          @item-click="callTab"
        />
        <XTForm :form-data="formData" @change="callForm" />
      </div>
    </div>
    <BasicTable @register="registerTable">
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'disable'">
          <span
            :class="['table-dot']"
            :style="{ backgroundColor: formatDictPreColor(responseTypeOptions, record.disable) }"
          />
          <span> {{ formatDictValue(responseTypeOptions, record.disable) }}</span>
        </template>
        <template v-if="column.key === 'supplierCategory'">
          <span>
            {{ formatDictValue(responsesupplierCategoryOptions, record.supplierCategory) }}</span
          >
        </template>
        <template v-if="column.key === 'action'">
          <TableAction
            :actions="[
              {
                auth: 'biz:drug:edit',
                icon: 'icon-xt-details_edit_default|iconfont',
                tooltip: '编辑',
                onClick: handleEdit.bind(null, record),
              },
              {
                auth: 'biz:drug:updateStatus',
                icon: 'icon-tingyong-moren|iconfont',
                tooltip: '停用',
                ifShow: record.disable === 0,
                popConfirm: {
                  title: '是否确认停用',
                  placement: 'left',
                  confirm: handleDelete.bind(null, record),
                },
              },
              {
                auth: 'biz:drug:updateStatus',
                icon: 'icon-xt-revocation_default|iconfont',
                tooltip: '启用',
                ifShow: record.disable === 1,
                popConfirm: {
                  title: '是否确认启用',
                  placement: 'left',
                  confirm: handleDelete.bind(null, record),
                },
              },
            ]"
          />
        </template>
      </template>
    </BasicTable>
    <FormModal @register="registerModal" @success="callSuccess" @cancel="handleCancel" />
    <ImportModal @register="registerImpModal" />
  </div>
</template>
<script lang="ts" setup>
  import { onBeforeMount, ref } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/TableCard';
  import { useMessage } from '/@/hooks/web/useMessage';
  import FormModal from './formModal.vue';
  import { ImportModal } from '/@/components/XTImport/index';

  import { formatDictValue, formatDictPreColor } from '/@/utils';
  import { columns } from './data';

  import {
    getpharmaceuticalsList,
    pharmaceuticalsDel,
    getStatusNumber,
    pharmaceuticalsExport,
    pharmaceuticalsImportBatch,
  } from '/@/api/biz/inventory/pharmaceuticalsApi';
  import { listDictModel } from '/@/api/common';
  import { useModal } from '/@/components/Modal';
  import { XTTitle } from '/@/components/XTTitle/index';
  import { XTTab } from '/@/components/XTTab/index';
  import { XTForm } from '/@/components/XTForm/index';

  // 标题数据
  const titleData = [
    {
      type: 'print',
      icon: 'icon-xt-print_default',
    },
    {
      type: 'import',
      auth: ['archives:drug:import'],
      icon: 'icon-xt-import_default',
    },
    {
      type: 'add',
      auth: ['biz:drug:add'],
      btnIcon: 'icon-xt-add_default',
      btnText: '新增药品',
    },
  ];
  // formdata
  const formData = [
    {
      name: 'shiftDate',
      componentType: 'RangePicker',
      format: 'YYYY-MM-DD',
      valueFormat: 'YYYY-MM-DD',
      placeholder: '请选择日期',
      width: 240,
    },
    {
      name: 'searchNames',
      componentType: 'Input',
      prefix: 'icon-xt-search',
      placeholder: '请输入药品名称',
      width: 240,
    },
  ];
  // tab 切换选中
  const tabSelected = ref();
  // 操作名称
  const searchNames = ref('');
  const shiftDate = ref([]);

  const typeOptions = ref();
  const responseTypeOptions = ref();
  const responsesupplierCategoryOptions = ref();
  onBeforeMount(async () => {
    responseTypeOptions.value = await listDictModel({ dictCode: 'sys_disable_type' });
    responsesupplierCategoryOptions.value = await listDictModel({ dictCode: 'pht' });
    getTab();
  });

  const { createMessage } = useMessage();
  const [registerModal, { openModal }] = useModal();
  const [registerImpModal, { openModal: openImpModal }] = useModal();

  // const tableSort = ref([
  //   {
  //     field: 'create_time',
  //     direction: 'DESC',
  //   },
  // ]) as any;

  const [registerTable, { reload, clearSelectedRowKeys }] = useTable({
    api: getpharmaceuticalsList,
    batchDelApi: pharmaceuticalsDel,
    // batchExportApi: pharmaceuticalsExport,
    delAuthList: ['biz:consumable:remove'],
    rowKey: 'id',
    columns,
    showIndexColumn: true,
    bordered: true,
    actionColumn: {
      width: 200,
      title: '操作',
      dataIndex: 'action',
    },
    beforeFetch: handleBeforeFetch,
  });
  // 详情按钮事件
  function handleEdit(record) {
    openModal(true, {
      record,
      isUpdate: true,
    });
  }

  // 新增按钮事件
  function callTitleClick(data) {
    if (data.type == 'add') {
      openModal(true, {
        isUpdate: false,
        record: data,
      });
    } else if (data.type == 'print') {
      console.log('打印中...');
    } else if (data.type == 'import') {
      openImpModal(true, {
        title: '导入药品数据',
        importUrl: pharmaceuticalsImportBatch,
        exportUrl: pharmaceuticalsExport,
      });
    }
  }

  // 删除按钮事件
  async function handleDelete(record: Recordable) {
    if (record) {
      await pharmaceuticalsDel(record.id);
      createMessage.success('停用成功！');
      clearSelectedRowKeys();
      await reload();
      await getTab();
    }
  }

  // 表格请求之前，对参数进行处理, 添加默认 排序
  async function handleBeforeFetch(params) {
    console.log('searchNames:::', searchNames.value);
    return {
      ...params,
      // orders: tableSort.value,
      name: searchNames.value == '' ? undefined : searchNames.value,
      status: tabSelected.value == '' ? undefined : tabSelected.value,
      time: shiftDate.value.length <= 0 ? undefined : shiftDate.value,
    };
  }

  async function getTab() {
    typeOptions.value = await listDictModel({ dictCode: 'sys_disable_type' });
    const typeNums = await getStatusNumber(); // 获取各类型数量
    let typeList = [];
    typeOptions.value.forEach(ele => {
      // 变量各类型放置对应数量
      let typeData = {};
      Object.keys(typeNums).forEach(numKey => {
        if (ele.value == numKey) {
          typeData = {
            key: ele.value,
            label: ele.label,
            value: typeNums[numKey],
            hasValue: true,
            prefixColor: ele.prefixColor,
            hasBracket: true,
          };
          typeList.push(typeData);
        }
      });
    });
    typeList = typeList.reverse();
    typeList.splice(0, 0, {
      key: '',
      label: '全部',
      value: typeNums.total,
      hasValue: true,
      hasBracket: true,
    });
    typeOptions.value = typeList;
    tabSelected.value = typeOptions.value[0].key;
  }

  //取消按钮事件
  async function handleCancel() {
    clearSelectedRowKeys();
    await reload();
    await getTab();
  }

  // 弹窗回调事件
  async function callSuccess({ isUpdate, values }) {
    console.log(isUpdate);
    console.log(values);
    await reload();
    await getTab();
  }
  // 选项卡组件回调
  async function callTab(data) {
    tabSelected.value = data.value;
    await reload();
  }

  // 查询组件回调
  async function callForm(data) {
    shiftDate.value = data.shiftDate ? data.shiftDate : '';
    searchNames.value = data.searchNames ? data.searchNames : '';
    console.log('callForm:::', searchNames.value);
    await reload();
  }
</script>
<style lang="less" scoped>
  .table-dot {
    display: inline-block;
    width: 10px;
    height: 10px;
    margin-right: 6px;
    border-radius: 50%;
  }

  ::v-deep(.ant-btn-link) {
    color: #3d4155;
  }

  .colUpdateAvatar {
    display: flex;
    justify-content: center;
    text-align: center;
    line-height: 28px;
  }

  .colImg {
    width: 28px;
    height: 28px;
    margin-right: 5px;
  }
</style>
